--KillTally.lua
--18 JULY 2014 05:52 EDT
--Author: Zendil-The Underbog
function KillTally_OnEvent(self, event, ...)
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		KillTally_OnCombatLogEvent(self, event, ...)
	elseif (event == "PLAYER_ENTERING_WORLD") then
		KillTally_OnJoinInstance()
	elseif (event == "PLAYER_DEAD") then
		KillTally_OnDeath()
	end
end
function KillTally_OnJoinInstance(self)
	local instanceType = select(2, IsInInstance())
	if (instanceType == "pvp") then
		KillTallyFrame:Show()
		print("PVP Area, KillTally shown.")
		KillTallyTotalKills = 0
		KillTallyKillStreak = 0
		KillTallyDeaths = 0
		KillTallyRatio = 0
	else
		KillTallyFrame:Hide()
		print("Non-PVP Area, KillTally hidden.")
	end
end
function KillTally_OnCombatLogEvent(self, event, ...)
	local instanceType = select(2, IsInInstance())
	if (instanceType == "pvp") then
		local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
		if (type == "PARTY_KILL") then
			local destType = tonumber(destGUID:sub(5,5), 16)
			local maskedDestType = destType % 8
			if (sourceGUID == UnitGUID("player") and maskedDestType == 0) then
				KillTallyTotalKills = KillTallyTotalKills + 1
				KillTallyKillStreak = KillTallyKillStreak + 1
				if (KillTallyDeaths == 0) then
					KillTallyRatio = 0
				else
					KillTallyRatio = string.format("%.2f", KillTallyTotalKills / KillTallyDeaths)
				end
				print("Killing Blow on "..destName..". Total: "..KillTallyTotalKills.." Streak: "..KillTallyKillStreak)
				KillTally_UpdateFrame()
			end
		end
	end
end
function KillTally_OnDeath(self)
	local instanceType = select(2, IsInInstance())
	if (instanceType == "pvp") then
		print("Killstreak ended. Previous streak: "..KillTallyKillStreak)
		KillTallyDeaths = KillTallyDeaths + 1
		KillTallyKillStreak = 0
		KillTally_UpdateFrame()
	end
end
function KillTally_UpdateFrame(self)
	if (KillTallyDeaths == 0) then
		KillTallyRatio = 0
	else
		KillTallyRatio = string.format("%.2f", KillTallyTotalKills / KillTallyDeaths)
	end
	frameText = "Total Kills: "..KillTallyTotalKills.."\nKill Streak: "..KillTallyKillStreak.."\nDeaths: "..KillTallyDeaths.."\nRatio: "..KillTallyRatio
	KillTallyText:SetText(frameText)
end
function KillTally_OnLoad(self)
	KillTallyFrame:RegisterForDrag("LeftButton")
	SlashCmdList["KillTallyCMD"] = KillTally_Command;
    SLASH_KillTallyCMD1 = "/KillTally";
	KillTallyFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	KillTallyFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	KillTallyFrame:RegisterEvent("PLAYER_DEAD")
	KillTallyTotalKills = 0
	KillTallyKillStreak = 0
	KillTallyDeaths = 0
	KillTallyRatio = 0
	KillTally_UpdateFrame()
end
function KillTally_OnUpdate(self)
	
end
function KillTally_DragStart(self)
    KillTallyFrame:StartMoving();
end
function KillTally_DragStop(self)
    KillTallyFrame:StopMovingOrSizing();
end
function KillTally_Command(msg)
	local setting = strsub(string.lower(msg), 1, 4);
	if( setting == "hide" ) then
		KillTallyFrame:Hide()
		print("KillTally hidden.");
	elseif( setting == "show" ) then
		KillTallyFrame:Show()
		print("KillTally showing.");
	else
		print("Commands are:"); 
		print("'/KillTally hide");
		print("'/KillTally show");
	end
end